-- ResurgenceMapControlRoutines.lua

--====================================================================
-- this script controls access to the maps of Resurgence
-- implementing the clickable buttons which make various maps visible
--====================================================================
-- ----------------------------
-- define tables of page visibility states
-- ----------------------------

-- table of all pages and objects
-- this is used to hide them all before drawing the currently visible ones

rmt_all = {
"DropDownButton",
"DropDown",
"DropUpButton",
"Button1",
"Button2",
"Button3",
"GotoSysButton",
"LeaveSysButton",
"ShowGlobe",
"GalaxyMap_lbl",
"GalaxyMap_nolbl",
"GalaxyMapButton",
"GalaxyMapButton2",
"GalaxyMapButton3",
"GalaxyMapButton4",
"GalaxyMapButton5",
"NeosolMap",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
"HyperionMap",
"HyperionMap_nosys",
"MundilfoeriMap",
"SolaMap",
"SuryaNayirMap",
"HeliosMap",
"MercariMap",
"NeogeaMap",
"SeshaMap",
"LunaMap",
"HephaestiMap",
"ScyllaMap",
"HadesMap",
"ThartarMap",
"GalaxyButton",
"NeosolButton",
"HyperionButton",
"HeliosButton",
"MercariButton",
"NeogeaButton",
"SeshaButton",
"LunaButton",
"HephaestiButton",
"ScyllaButton",
"HadesButton",
"ThartarButton",
"HeliosGlobeLbl",
"MercariGlobeLbl",
"NeogeaGlobeLbl",
"SeshaGlobeLbl",
"LunaGlobeLbl",
"HephaestiGlobeLbl",
"ScyllaGlobeLbl",
"HadesGlobeLbl",
"ThartarGlobeLbl",
"HeliosGlobeNoLbl",
"MercariGlobeNoLbl",
"NeogeaGlobeNoLbl",
"SeshaGlobeNoLbl",
"LunaGlobeNoLbl",
"HephaestiGlobeNoLbl",
"ScyllaGlobeNoLbl",
"HadesGlobeNoLbl",
"ThartarGlobeNoLbl",
   "NSSNFlag",
   "NSMFlag",
   "NSLFlag",
   "NSHFlag",
-- popout neosol orrery
"NSOButton",
"NeoSolBlank",
"RM_grid_sphere",
"RM_map_flat",
"RM_grid_flat",
"NeoSol..",
"Surya..",
"Nayir..",
"Mundilfoeri..",
"Sola..",
"Hyperion..",
}

-- Neosol orrery visible components
rmt_nsorrey = {
"NeoSolBlank",
"DropDownButton",
"NSOButton",
"GalaxyMapButton5",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
"RM_grid_sphere",
"RM_map_flat",
"RM_grid_flat",
"Surya..",
"Nayir..",
"Mundilfoeri..",
"Sola..",
"Hyperion..",
}

-- ----------
-- drop-down menu buttons 
-- ----------
rmt_ddm = {
"DDb1",
"DDb2",
"DDb3",
"DDb4",
"DDb5",
"DDb6",
"DDb7",
"DDb8",
"DDb9",
"DDb10",
"DDb11",
"DDb12",
"DDb13",
"DDb14",
"DDb15",
"DDb16",
"DDb17",
"DDb18",
"DDb19",
"DDb20",
"DDb21",
"DDb22",
"DDb23",
"DDb24",
"DDb25",
"DDb26",
}
-- ----------
-- fancy buttons on Neosol map
-- ----------
rmt_nssb = {
   "NeosolMap",
"GalaxyButton",
"NSOButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
   "NSSNFlag",
}
rmt_nsnb = {
   "NeosolMap",
"GalaxyButton",
"NSOButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
   "NSSNFlag",
}
rmt_nsmb = {
   "NeosolMap",
"GalaxyButton",
"NSOButton",
"NSSuryaButton",
"NSNayirButton",
"NSSolaButton",
"NSHyperionButton",
   "NSMFlag",
}
rmt_nslb = {
   "NeosolMap",
"GalaxyButton",
"NSOButton",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSHyperionButton",
   "NSLFlag",
}
rmt_nshb = {
   "NeosolMap",
"GalaxyButton",
"NSOButton",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSSolaButton",
   "NSHFlag",
}

-- ---------
-- System maps
-- ---------
rmt_galaxy_nolbl = {
"GalaxyMap_nolbl",
"GalaxyMapButton",
"GalaxyMapButton2",
}
rmt_galaxy_lbl = {
"GalaxyMap_lbl",
"GalaxyMapButton3",
"GalaxyButton",
}
rmt_neosol = {
"NeosolMap",
"NSOButton",
"GalaxyMapButton5",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
}
rmt_hyp = {
"HyperionMap",
"NeosolButton",
"Button1",
"Button2",
"Button3",
"HeliosButton",
"MercariButton",
"NeogeaButton",
"SeshaButton",
"LunaButton",
"HephaestiButton",
"ScyllaButton",
"HadesButton",
"ThartarButton",
"GotoSysButton",
}
rmt_hyp_pb = {
"HeliosButton",
"MercariButton",
"NeogeaButton",
"SeshaButton",
"LunaButton",
"HephaestiButton",
"ScyllaButton",
"HadesButton",
"ThartarButton",
}

rmt_mund = {
"MundilfoeriMap",
"NeosolButton",
"Button1",
"Button2",
"Button3",
}

rmt_sola = {
"SolaMap",
"NeosolButton",
"Button1",
"Button2",
"Button3",
}

rmt_surya = {
"SuryaNayirMap",
"NeosolButton",
"Button1",
"Button2",
"Button3",
}

-- ---------
-- Planetary maps
-- ---------

rmt_sesha = {
"SeshaMap",
"HyperionButton",
"ShowGlobe",
}

rmt_helios = {
"HeliosMap",
"HyperionButton",
"ShowGlobe",
}

rmt_merc = {
"MercariMap",
"HyperionButton",
"ShowGlobe",
}

rmt_neo = {
"NeogeaMap",
"HyperionButton",
"ShowGlobe",
}

rmt_luna = {
"LunaMap",
"HyperionButton",
"ShowGlobe",
}

rmt_heph = {
"HephaestiMap",
"HyperionButton",
"ShowGlobe",
}

rmt_scylla = {
"ScyllaMap",
"HyperionButton",
"ShowGlobe",
}
rmt_hades = {
"HadesMap",
"HyperionButton",
"ShowGlobe",
}
rmt_thartar = {
"ThartarMap",
"HyperionButton",
"ShowGlobe",
}

-- dotted "popout" system(s)
rmt_dotsh = {
 "Hyperion.",
 "Hyperion./Helios.",
 "Hyperion./Helios./Mercari.",
 "Hyperion./Neogea.",
 "Hyperion./Neogea./Hecate.",
 "Hyperion./Hira.",
 "Hyperion./Hira./Sesha.",
 "Hyperion./Hira./Luna.",
 "Hyperion./Hira./Hephaesti.",
 "Hyperion./Poseidon.",
 "Hyperion./Poseidon./Proteus.",
 "Hyperion./Poseidon./Hydros.",
 "Hyperion./Poseidon./Neris.",
 "Hyperion./Poseidon./Scylla.",
 "Hyperion./Hades.",
 "Hyperion./Hades./Persephone.",
 "Hyperion./Thartar.",
}
-- ----------------------------
-- functions to hide and show the maps
-- ----------------------------

-- ---------------
show = function (name)
   celestia:find(name):setvisible(true)
end

-- ---------------
hide = function (name)
   celestia:find(name):setvisible(false)
end
-- ---------------

show_tbl = function (map_table)
  for j,r in ipairs(map_table) do
   celestia:find(map_table[j]):setvisible(true)
  end -- for j,r loop
end

-- ---------------
hide_tbl = function (map_table)
  for j,r in ipairs(map_table) do
   celestia:find(map_table[j]):setvisible(false)
  end -- for j,r loop
end

-- ---------------

-- hide all maps and buttons
show_none = function ()
  hide_tbl(rmt_all)
      local obj=celestia:find("ResurgenceCore")
      celestia:select(obj)
  hide_tbl(rmt_dotsh)
  hide_tbl(rmt_ddm)
      local obj=celestia:find("Maps")
      celestia:select(obj)
     celestia:setorbitflags{ Spacecraft = false }
     celestia:setlabelflags{ spacecraft = false }
end

-- show a map and its buttons

show_map = function (map_table)
-- turn all stuff off
  show_none()
  celestia:setorbitflags{ Spacecraft = false }
  celestia:setlabelflags{ spacecraft = false }
  celestia:setorbitflags{ Planet = false }
  celestia:setlabelflags{ planets = false }

-- turn this stuff on
  show("DropDownButton")
  for j,r in ipairs(map_table) do
   celestia:find(map_table[j]):setvisible(true)
  end -- for j,r loop
end

--====================================================================
-- command routines
--====================================================================
-- button 1
rmc_b1 = function ()
      if celestia:find("HyperionMap"):visible()
      then      show_map(rmt_sola)
      elseif  celestia:find("SolaMap"):visible()
      then	show_map(rmt_mund)
      elseif celestia:find("MundilfoeriMap"):visible()
      then	show_map(rmt_sola)
      elseif  celestia:find("SuryaNayirMap"):visible()
      then	show_map(rmt_mund)
      else	show_map(rmt_hyp)
      end
end
-- button 2
rmc_b2 = function ()
      if celestia:find("HyperionMap"):visible()
      then	show_map(rmt_mund)
      elseif  celestia:find("SolaMap"):visible()
      then	show_map(rmt_hyp)
      elseif celestia:find("MundilfoeriMap"):visible()
      then	show_map(rmt_hyp)
      elseif  celestia:find("SuryaNayirMap"):visible()
      then      show_map(rmt_sola)
      else	show_map(rmt_hyp)
      end
end
-- button 3
rmc_b3 = function ()
      if celestia:find("HyperionMap"):visible()
      then	show_map(rmt_surya)
      elseif  celestia:find("SolaMap"):visible()
      then	show_map(rmt_surya)
      elseif celestia:find("MundilfoeriMap"):visible()
      then	show_map(rmt_surya)
      elseif  celestia:find("SuryaNayirMap"):visible()
      then	show_map(rmt_hyp)
      else	show_map(rmt_hyp)
      end
end


rmc_toggle_globe = function ()
-- swtch labled to unlabeled globe
      if celestia:find("HeliosGlobeLbl"):visible()
      then
	celestia:find("HeliosGlobeLbl"):setvisible(false)
	celestia:find("HeliosGlobeNoLbl"):setvisible(true)
      elseif  celestia:find("MercariGlobeLbl"):visible()
      then
	celestia:find("MercariGlobeLbl"):setvisible(false)
	celestia:find("MercariGlobeNoLbl"):setvisible(true)
      elseif celestia:find("NeogeaGlobeLbl"):visible()
      then
	celestia:find("NeogeaGlobeLbl"):setvisible(false)
	celestia:find("NeogeaGlobeNoLbl"):setvisible(true)
      elseif celestia:find("SeshaGlobeLbl"):visible()
      then
	celestia:find("SeshaGlobeLbl"):setvisible(false)
	celestia:find("SeshaGlobeNoLbl"):setvisible(true)
      elseif celestia:find("LunaGlobeLbl"):visible()
      then
	celestia:find("LunaGlobeLbl"):setvisible(false)
	celestia:find("LunaGlobeNoLbl"):setvisible(true)
      elseif celestia:find("HephaestiGlobeLbl"):visible()
      then
	celestia:find("HephaestiGlobeLbl"):setvisible(false)
	celestia:find("HephaestiGlobeNoLbl"):setvisible(true)
      elseif celestia:find("ScyllaGlobeLbl"):visible()
      then
	celestia:find("ScyllaGlobeLbl"):setvisible(false)
	celestia:find("ScyllaGlobeNoLbl"):setvisible(true)
      elseif celestia:find("HadesGlobeLbl"):visible()
      then
	celestia:find("HadesGlobeLbl"):setvisible(false)
	celestia:find("HadesGlobeNoLbl"):setvisible(true)
      elseif celestia:find("ThartarGlobeLbl"):visible()
      then
	celestia:find("ThartarGlobeLbl"):setvisible(false)
	celestia:find("ThartarGlobeNoLbl"):setvisible(true)
-- else hide nolbl globes
      elseif celestia:find("HeliosGlobeNoLbl"):visible()
      then        celestia:find("HeliosGlobeNoLbl"):setvisible(false)
      elseif  celestia:find("MercariGlobeNoLbl"):visible()
      then        celestia:find("MercariGlobeNoLbl"):setvisible(false)
      elseif celestia:find("NeogeaGlobeNoLbl"):visible()
      then        celestia:find("NeogeaGlobeNoLbl"):setvisible(false)
      elseif celestia:find("SeshaGlobeNoLbl"):visible()
      then        celestia:find("SeshaGlobeNoLbl"):setvisible(false)
      elseif celestia:find("LunaGlobeNoLbl"):visible()
      then        celestia:find("LunaGlobeNoLbl"):setvisible(false)
      elseif celestia:find("HephaestiGlobeNoLbl"):visible()
      then        celestia:find("HephaestiGlobeNoLbl"):setvisible(false)
      elseif celestia:find("ScyllaGlobeNoLbl"):visible()
      then        celestia:find("ScyllaGlobeNoLbl"):setvisible(false)
      elseif celestia:find("HadesGlobeNoLbl"):visible()
      then        celestia:find("HadesGlobeNoLbl"):setvisible(false)
      elseif celestia:find("ThartarGlobeNoLbl"):visible()
      then        celestia:find("ThartarGlobeNoLbl"):setvisible(false)
-- otherwise show the labeled globe for this map
      elseif celestia:find("HeliosMap"):visible()
      then        celestia:find("HeliosGlobeLbl"):setvisible(true)
      elseif  celestia:find("MercariMap"):visible()
      then        celestia:find("MercariGlobeLbl"):setvisible(true)
      elseif celestia:find("NeogeaMap"):visible()
      then        celestia:find("NeogeaGlobeLbl"):setvisible(true)
      elseif celestia:find("SeshaMap"):visible()
      then        celestia:find("SeshaGlobeLbl"):setvisible(true)
      elseif celestia:find("LunaMap"):visible()
      then        celestia:find("LunaGlobeLbl"):setvisible(true)
      elseif celestia:find("HephaestiMap"):visible()
      then        celestia:find("HephaestiGlobeLbl"):setvisible(true)
      elseif celestia:find("ScyllaMap"):visible()
      then        celestia:find("ScyllaGlobeLbl"):setvisible(true)
      elseif celestia:find("HadesMap"):visible()
      then        celestia:find("HadesGlobeLbl"):setvisible(true)
      elseif celestia:find("ThartarMap"):visible()
      then        celestia:find("ThartarGlobeLbl"):setvisible(true)
     end
     celestia:setorbitflags{ Spacecraft = false }
     celestia:setlabelflags{ spacecraft = false }
end

rmc_show_orrery = function ()
     celestia:setrenderflags{ orbits = true }
     celestia:setorbitflags{ Spacecraft = true }
     celestia:setlabelflags{ spacecraft = true }
     hide("GotoSysButton")
     show("LeaveSysButton")
     hide("HyperionMap")
     hide_tbl(rmt_hyp_pb)
     show("HyperionMap_nosys")
      local obj=celestia:find("ResurgenceCore")
      celestia:select(obj)
     show_tbl(rmt_dotsh)
      local obj=celestia:find("Maps")
      celestia:select(obj)
end

rmc_hide_orrery = function ()
     celestia:setorbitflags{ Spacecraft = false }
     celestia:setlabelflags{ spacecraft = false }
     show("GotoSysButton")
     hide("LeaveSysButton")
     show("HyperionMap")
     show_tbl(rmt_hyp_pb)
     hide("HyperionMap_nosys")
      local obj=celestia:find("ResurgenceCore")
      celestia:select(obj)
     hide_tbl(rmt_dotsh)
      local obj=celestia:find("Maps")
      celestia:select(obj)
end

rmc_dd = function()
	   show ("DropDown")
	   show_tbl (rmt_ddm)
	   show ("DropUpButton")
	   hide ("DropDownButton")
end
rmc_du = function()
	   hide ("DropDown")
	   hide_tbl (rmt_ddm)
	   hide ("DropUpButton")
	   show ("DropDownButton")
end

rmc_nsorrey = function ()
      if celestia:find("NeoSolBlank"):visible()
      then
        show_map(rmt_neosol)
      else
	show_map(rmt_nsorrey)
	celestia:setorbitflags{ Planet = true }
  	celestia:setlabelflags{ planets = true }
      end
end

-- leave maps and go to hyperion system
rmc_gotohyp = function()
  celestia:setorbitflags{ Planet = true }
  celestia:setorbitflags{ Moon = true }
  celestia:setlabelflags{ planets = true}
  celestia:setlabelflags{ moons = true}
  local mars = celestia:find("Hyperion")
  celestia:select(mars)
  local frame = celestia:newframe("ecliptic", mars)
  local obs = celestia:getobserver()
  obs:setframe(frame)
  local marsradius = mars:radius()
  local marsdistance = 7.0e3 * marsradius
  local upaxis = celestia:newvector(0,1,0)
  obs:gotodistance(mars, marsdistance, 5.0, upaxis)

end


--====================================================================
-- command processor
-- the name of the selected object is interpreted as a command
--====================================================================

-- selP = previous selection
-- to be restored immediately after recognizing a command
-- assume initial selection (if any) when Celestia starts isn't a command

-- must be initialized; can't use getselection yet

selP = nil

-- table of commands:
-- command text (name of selected object) = command function,

rmt_cmds = {
 DropDownButton = {rmc_dd,nil},
 DropUpButton = {rmc_du,nil},
 Button1 = {rmc_b1,nil},
 Button2 = {rmc_b2,nil},
 Button3 = {rmc_b3,nil},
 GalaxyMapButton = {show_map,rmt_galaxy_lbl},
 GalaxyMapButton2 = {show_map,rmt_galaxy_lbl},
 GalaxyMapButton5 = {show_map,rmt_galaxy_lbl},
 GalaxyMapButton3 = {show_map,rmt_neosol},
 GalaxyMap_lbl = {show_map,rmt_neosol},
 NeosolMap = {show_map,rmt_hyp},
 HyperionMap  =  {show_map,rmt_neosol},
 HyperionMap_nosys  =  {show_map,rmt_neosol},
 MundilfoeriMap  =  {show_map,rmt_neosol},
 SolaMap = {show_map,rmt_neosol},
 SuryaNayirMap = {show_map,rmt_neosol},
 HeliosMap = {show_map,rmt_neosol},
 MercariMap = {show_map,rmt_neosol},
 NeogeaMap = {show_map,rmt_neosol},
 SeshaMap = {show_map,rmt_neosol},
 LunaMap = {show_map,rmt_neosol},
 HephaestiMap = {show_map,rmt_neosol},
 ScyllaMap = {show_map,rmt_neosol},
 HadesMap = {show_map,rmt_neosol},
 ThartarMap = {show_map,rmt_neosol},
 NSSuryaButton = {show_map,rmt_nssb},
 NSNayirButton = {show_map,rmt_nsnb},
 NSMundilfoeriButton = {show_map,rmt_nsmb},
 NSSolaButton = {show_map,rmt_nslb},
 NSHyperionButton = {show_map,rmt_nshb},
 GalaxyButton = {show_map,rmt_galaxy_nolbl},
 NeosolButton = {show_map,rmt_neosol},
 HyperionButton = {show_map,rmt_hyp},
 HeliosButton = {show_map,rmt_helios},
 MercariButton = {show_map,rmt_merc},
 NeogeaButton = {show_map,rmt_neo},
 SeshaButton = {show_map,rmt_sesha},
 LunaButton = {show_map,rmt_luna},
 HephaestiButton = {show_map,rmt_heph},
 ScyllaButton = {show_map,rmt_scylla},
 HadesButton = {show_map,rmt_hades},
 ThartarButton = {show_map,rmt_thartar},
 ShowGlobe = {rmc_toggle_globe, nil},
 GotoSysButton = {rmc_show_orrery,nil},
 LeaveSysButton = {show_map,rmt_hyp},
 NSSNFlag = {show_map,rmt_surya},
 NSMFlag = {show_map,rmt_mund},
 NSLFlag = {show_map,rmt_sola},
 NSHFlag = {show_map,rmt_hyp},
--
 DDb1 = {rmc_du,nil},
 DDb2 = {show_map,rmt_galaxy_nolbl},
 DDb3 = {show_map,rmt_galaxy_lbl},
 DDb4 = {show_map,rmt_neosol},
 DDb5 = {show_map,rmt_surya},
 DDb6 = {show_map,rmt_mund},
 DDb7 = {show_map,rmt_sola},
 DDb8 = {show_map,rmt_hyp},
 DDb9 = {show_map,rmt_helios},
 DDb10 = {show_map,rmt_merc},
 DDb11 = {show_map,rmt_neo},
 DDb12 = {rmc_du,nil},
 DDb13 = {rmc_du,nil},
 DDb14 = {show_map,rmt_sesha},
 DDb15 = {show_map,rmt_luna},
 DDb16 = {show_map,rmt_heph},
 DDb17 = {rmc_du,nil},
 DDb18 = {rmc_du,nil},
 DDb19 = {rmc_du,nil},
 DDb20 = {rmc_du,nil},
 DDb21 = {show_map,rmt_scylla},
 DDb22 = {show_map,rmt_hades},
 DDb23 = {rmc_du,nil},
 DDb24 = {show_map,rmt_thartar},
 DDb25 = {rmc_du,nil},
 DDb26 = {rmc_gotohyp,nil},
-- neosol orrery
 NSOButton = {rmc_nsorrey,nil},
 RM_map_flat = {hide,"RM_map_flat"},
 }
 
-- action function

rmc_rm_cmd = function (this_date)

  local sel = celestia:getselection()

  if (sel == selP) then return 0 end
  
  local sname = sel:name()

  local todo = rmt_cmds[sname]
    if todo then 
     -- restore previous selection before executing this one
        if (selP ~= nil) then celestia:select(selP) end
	todo[1](todo[2])
	return 1
    end

-- This selection is not recognized as a command: 
-- so save it for reversion after next command

	selP = sel
	return 0
end

